// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

class PAIR { // A key-pointer pair stored in B+-tree nodes
public:
  void* ptr; // Elem* for leaves, BPNode* for internals
  int pkey;
};


class BPNode {          // The B+-tree node class
public:
  PAIR recs[MAXREC];    // Array of key/pointer pairs
  int numrec;           // Number of records stored
  BPNode* lftptr;  BPNode* rghtptr; // Links to siblings
  bool isLeaf() const;  // True if the node is a leaf
  bool isFull() const;  // True if the node is full
};
